SystemOrganization addCategory: #'Ma exception handling-Requests'!
SystemOrganization addCategory: #'Ma exception handling-exceptions'!
SystemOrganization addCategory: #'Ma exception handling-Info'!

Notification subclass: #MaNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

MaNotification subclass: #MaNetworkNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaNotification methodsFor: 'as yet unclassified' stamp: 'cmm 3/28/2005 21:52'!
messageText

	^super messageText ifNil: [ self species name, ' - no detailed message available' ]! !

!Object methodsFor: '*ma exception handling' stamp: 'cmm 12/30/2007 18:41'!
copyAttributes: anArray from: sourceObject

	anArray do:
		[ :each |
		self
			instVarNamed: each asString
			put: (sourceObject instVarNamed: each) copy ]! !

!Object methodsFor: '*ma exception handling' stamp: 'cmm 2/15/2002 00:02'!
maIsException

	^false
! !

PackageInfo subclass: #MaExceptionHandlingPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-Info'!

!MaExceptionHandlingPackageInfo class methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2009 15:41'!
packageName
	^ 'Ma exception handling'! !

!Exception class methodsFor: '*ma exception handling' stamp: 'cmm 9/18/2005 23:56'!
messageText: aString

	^ self new
		messageText: aString ;
		yourself! !

!Exception methodsFor: '*ma exception handling' stamp: 'cmm 9/28/2008 18:18'!
isMaUserError

	^false! !

!Exception methodsFor: '*ma exception handling' stamp: 'cmm 8/11/2002 23:35'!
maIsException

	^true! !

Exception subclass: #MaRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-Requests'!

MaRequest subclass: #MaStringRequest
	instanceVariableNames: 'initialAnswer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-Requests'!

!MaStringRequest commentStamp: 'cmm 10/9/2005 12:01' prior: 0!
Some applications need to prompt the user for a String at an inopportune time; for example some operations may require the users privateKey file and we want to do this on a JIT basis.

The purpose of this class is to provide a default way to ask the user for a String while allowing programs to override with their own approach.!

MaStringRequest subclass: #MaFileRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-Requests'!

!MaFileRequest class methodsFor: 'create' stamp: 'cmm 11/16/2005 22:11'!
message: aString filename: filenameString initialDirectory: aFileDirectory

	^ self new
		messageText: aString, '.  Where is ', filenameString, '?' ;
		initialAnswer: aFileDirectory fullName ;
		yourself! !

!MaStringRequest class methodsFor: 'create' stamp: 'cmm 9/27/2005 00:49'!
messageText: messageString initialAnswer: initialAnswerString

	^ (self messageText: messageString) 
		initialAnswer: initialAnswerString ;
		yourself! !

!MaStringRequest methodsFor: 'initialize-release' stamp: 'cmm 11/16/2005 22:29'!
defaultAction
	self resume:
		(FillInTheBlank 
			request: self messageText
			initialAnswer: self initialAnswer)! !

!MaStringRequest methodsFor: 'accessing' stamp: 'cmm 9/27/2005 00:46'!
initialAnswer
	^ initialAnswer ifNil: [ String maEmpty ]! !

!MaStringRequest methodsFor: 'initialize-release' stamp: 'cmm 9/27/2005 00:49'!
initialAnswer: aString
	initialAnswer := aString! !

Warning subclass: #MaWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaWarning methodsFor: 'as yet unclassified' stamp: 'cmm 9/16/2008 15:35'!
defaultAction
	SmalltalkImage current maIsHeadless
		ifTrue: [ self resume ]
		ifFalse: [ super defaultAction ]! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/23/2008 15:12'!
defaultMaxMemory
	"As of Squeak3.9, the max size of an image is somewhere between 450MB and 500MB.  Use the lower bound for safety."
	^ 450000000! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/16/2008 15:34'!
maIsHeadless
	"Display global appears to be set even when headless.  So checking the -vm arguments looking for headless operation."
	-1000 
		to: -1
		do: 
			[ : n | 
			(#('display=none' '-headless' ) includes: (self getSystemAttribute: n)) ifTrue: [ ^ true ] ].
	^ false! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/23/2008 14:59'!
maIsLowOnMemory
	"Answer whether the VM is within ten-million bytes of available memory.  The goal is to avoid the LowSpace warning."
	^ self maMemoryAvailable < 10000000! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/23/2008 15:54'!
maMaxMemory
	"If the special argument to the vm, -memory, was provided, use number following it.  Else 450MB."
	| foundMemoryArg |
	foundMemoryArg := false.
	self maVmParametersDo: 
		[ : each | 
		'-memory' = each 
			ifTrue: [ foundMemoryArg := true ]
			ifFalse: 
				[ foundMemoryArg ifTrue: 
					[ | arg |
					arg := each.
					(arg isEmptyOrNil or: [ arg size < 2 ]) ifFalse: 
						[ | requestedMemory |
						requestedMemory := (arg 
							copyFrom: 1
							to: arg size - 1) asNumber.
						requestedMemory > 0 ifTrue: 
							[ arg last = $k 
								ifTrue: [ ^ 1000 * requestedMemory ]
								ifFalse: [ arg last = $m ifTrue: [ ^ 1000000 * requestedMemory ] ] ] ] ] ] ].
	^ self defaultMaxMemory! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/23/2008 15:06'!
maMemoryAvailable
	"Answer the remaining memory available accessible by this image."
	^ self maMaxMemory - self maMemoryUsed! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/23/2008 15:59'!
maMemoryUsed
	^ (self vmParameterAt: 2) max: (self vmParameterAt: 1)! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/23/2008 15:49'!
maVmParameters
	| answer |
	answer := OrderedCollection new.
	self maVmParametersDo: [ : each | answer add: each ].
	^ answer! !

!SmalltalkImage methodsFor: '*ma exception handling' stamp: 'cmm 9/23/2008 15:51'!
maVmParametersDo: aBlock 
	"Display global appears to be set even when headless.  So checking the -vm arguments looking for headless operation."
	-1 
		to: -1000
		by: -1
		do: 
			[ : n | 
			| attr |
			attr := self getSystemAttribute: n.
			attr ifNotNil: [ aBlock value: attr ] ]! !

Error subclass: #MaError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaError commentStamp: '<historical>' prior: 0!
Base abstraction for errors that occur in Ma code.!

MaError subclass: #MaCorruptionError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

MaError subclass: #MaEnvironmentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

MaError subclass: #MaSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaSoftwareError commentStamp: 'cmm 5/4/2005 10:25' prior: 0!
A software error is a bug in the software.  Signal them when you have to code for something that "should never happen."  For example, if, based on your program logic, there should be an entry in a Dictionary, but it is not there, you would signal a software error.!

MaError subclass: #MaUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma exception handling-exceptions'!

!MaUserError commentStamp: '<historical>' prior: 0!
I represent an error made by the user.!

!MaUserError methodsFor: 'as yet unclassified' stamp: 'cmm 9/28/2008 18:18'!
isMaUserError

	^true! !
